<template>
  <div class="container">
    <!-- 查询配置 -->
    <div style="padding: 0px 20px">
      <div ref="lxHeader">
        <LxHeader icon="md-apps" text="项目安全管理" style="margin-bottom: 10px; border: 0px; margin-top: 15px">
          <div slot="content"></div>
          <slot>
            <div>
              <Input style="width: 200px; margin-right: 10px" v-model="searchFields.KeyWord" placeholder="关键字搜索" />
              <Button type="primary" @click="load" style="margin-left: 10px">查询</Button>
              <Button type="primary" @click="edit()" style="margin-left: 10px">新增</Button>
            </div>
          </slot>
        </LxHeader>
      </div>
      <div ref="lxTable">
        <el-table :data="tableData" :height="tableHeight" style="width: 100%">
          <el-table-column type="index" width="50" align="center" label="序号" fixed='left'> </el-table-column>
          <el-table-column :prop="column.field" :align="column.align" v-for="(column,index) in columns"
            :label="column.title" :width="column.width" :fixed="column.fixed">
            <template slot-scope="scope">
              <div v-if="column.type=='opt'">
                <Button ghost size="small" @click="edit(scope.row)" type="primary"
                  style="margin-left: 10px;">编辑</Button>
                <Button ghost size="small" @click="del(scope.row)" type="error" style="margin-left: 10px;">删除</Button>
              </div>
              <div v-else-if="column.type=='format'">
                <div v-if="column.field=='admin'">
                  {{scope.row[column.field]?scope.row[column.field].name:""}}
                </div>
                <div v-if="column.field=='department'">
                  {{scope.row[column.field]?scope.row[column.field].name:""}}
                </div>
              </div>
              <div v-else>{{scope.row[column.field]}}</div>
            </template>
          </el-table-column>
        </el-table>
        <div class="pagination">
          <el-pagination @current-change="handleCurrentChange" :current-page="paginations.page"
            :page-size="paginations.page_size" background layout="prev, pager, next" :total="paginations.total">
          </el-pagination>
        </div>
      </div>

    </div>

    <el-dialog title="项目安全管理编辑" :visible.sync="dialogFormVisible" fullscreen width="90%">
      <div class="dialogConcent" :style="{height:clientHeight+'px'}">
        <el-scrollbar style="flex: 1">
          <el-form :model="form" :rules="rules" ref="form" label-position="right" :label-width="formLabelWidth">
            <el-form-item label="项目名称" prop="name">
              <el-input v-model="form.name" placeholder="请填写项目名称" autocomplete="off"></el-input>
            </el-form-item>
            <el-row>
              <el-col :span="8">
                <el-form-item label="检查地点" prop="address" label-position="right">
                  <el-input v-model="form.address" placeholder="请填写检查地点" autocomplete="off"></el-input>
                </el-form-item>
              </el-col>
              <el-col :span="8" :offset="8">
                <el-form-item label="检查时间" prop="date" label-position="right">
                  <el-date-picker style="width:100%" type="date" v-model="form.date" value-format="yyyy-MM-dd HH:mm:ss"
                   placeholder="检查时间">
                  </el-date-picker>
                </el-form-item>
              </el-col>
            </el-row>
            <el-row>
              <el-col :span="8">
                <el-form-item label="建设单位" prop="build_unit" label-position="right">
                  <el-input v-model="form.build_unit" placeholder="请填写建设单位" autocomplete="off"></el-input>
                </el-form-item>
              </el-col>
              <el-col :span="8" :offset="8">
                <el-form-item label="施工单位" prop="carry_unit" label-position="right">
                  <el-input v-model="form.carry_unit" placeholder="请填写施工单位" autocomplete="off"></el-input>
                </el-form-item>
              </el-col>
            </el-row>
            <el-form-item class="longtext" label="备注" prop="remark">
              <el-input type="textarea" :rows="3" v-model="form.remark" placeholder="请填写备注" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="附件" prop="file_list">
              <el-upload class="upload-demo" :on-success="handlesuccess" :data="uploadOther"
                :action="action" :on-remove="handleRemove" :before-remove="beforeRemove"
                :on-exceed="handleExceed" :file-list="fileList">
                <el-button size="small" type="primary">点击上传</el-button>
              </el-upload>
            </el-form-item>
            <div style="padding: 20px 0px;" class="form-sub-title">
              <span>详细信息
              </span>
            </div>
            <div class="table-tree tableswidth">
              <div style="display: flex;justify-content: flex-end;margin-right: 20px;margin-bottom: 10px;">
                <Button type="primary" @click="addRow()" size="small" style="margin-left: 10px;" ghost>新增</Button>
              </div>
              <el-table :data="this.form.details_list" height="400" class="v-table" style="width: 100%;margin-bottom: 20px;">
                <el-table-column type="index" align="center" label="序号">
                </el-table-column>

                <el-table-column prop="name" label="检查项目" width="220px">
                  <template slot-scope="scope">
                    <el-input v-model="scope.row.name" /></el-input>
                  </template>
                </el-table-column>
                <el-table-column prop="status" align="center" label="完成情况" width="200px">
                  <template slot-scope="scope">
                    <el-select v-model="scope.row.status" placeholder="请选择完成情况" style="width: 100%">
                      <el-option v-for="item in parameters.safetyStatus" :key="item.id" :label="item.value"
                        :value="item.id">
                      </el-option>
                    </el-select>
                  </template>
                </el-table-column>
                <el-table-column prop="measure" align="center" label="对发现的问题拟采取的措施">
                  <template slot-scope="scope">
                    <el-input v-model="scope.row.measure" /></el-input>
                  </template>
                </el-table-column>
                <el-table-column prop="remark" align="center" label="备注">
                  <template slot-scope="scope">
                    <el-input v-model="scope.row.remark" /></el-input>
                  </template>
                </el-table-column>

                <el-table-column label="操作" width="120px" align="center">
                  <template slot-scope="scope">
                    <Button type="error" @click="delRow(scope.$index)" size="small" style="margin-left: 10px;"
                      ghost>删除</Button>
                  </template>
                </el-table-column>
              </el-table>
            </div>
          </el-form>
        </el-scrollbar>
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button @click="resetForm('form')">取 消</el-button>
        <el-button type="primary" v-preventReClick @click="submitForm('form')">确 定</el-button>
      </div>
    </el-dialog>


  </div>
</template>

<script>
  import {
    getToken
  } from '@/utils/auth'
  import LxHeader from "@/components/LxHeader/index.vue";
  import Tinymce from '@/components/Tinymce'
  import {
    save,
    store,
    del,
    get,
    listtask
  } from "../../api/site/safetyitem.js";
  import {
    getparameteritem
  } from "../../api/system/dictionary.js";
  export default {
    components: {
      LxHeader,
      Tinymce
    },
    data() {
      return {      action:`${process.env.VUE_APP_BASE_API}api/admin/upload-file`,
        checkAll: false,
        isIndeterminate: true,
        infoFormVisible:false,
        parameters: {
          safetyStatus:[]
        },
        paginations: {
          page: 1,
          page_size: 15,
          total: 0
        },
        tableHeight: 0,
        dialogFormVisible: false,
        formLabelWidth: "120px",
        clientHeight: 0,
        form: {
          name: "",
          address: "",
          date:"",
          build_unit: "",
          carry_unit: "",
          file_list: "",
          remark: "",
          details_list: [{
            name:"",
            status:"",
            measure:"",
            remark:""
          }],
        },
        //查询条件字段
        searchFields: {
          KeyWord: ""
        },
        fileList:[],
        details_list: [],
        tableData: [],
        rules: {
          name: [{
            message: '请填写项目名称',
            trigger: 'blur'
          }],
          address: [{
            required: true,
            message: '请填写检查地点',
            trigger: 'blur'
          }],
          date: [{
            message: '请选择检查时间',
            trigger: 'blur'
          }],
          build_unit: [{
            message: '请填写建设单位',
            trigger: 'blur'
          }],
          carry_unit: [{
            message: '请填写施工单位',
            trigger: 'blur'
          }],
          remark: [{
            message: '请填写备注',
            trigger: 'blur'
          }],
        },
        columns: [{
            field: "name",
            title: "项目名称",
            type: "string",
            align: "left",
            width: 240,
          },
          {
            field: "date",
            title: "检查时间",
            type: "string",
            width: 120,
            align: "center"
          },
          {
            field: "address",
            title: "检查地点",
            type: "string",
            align: "left",
            width: 240,
          },
          {
            field: "build_unit",
            title: "建设单位",
            type: "string",
            align: "left",
            width: 180,
          },
          {
            field: "carry_unit",
            title: "施工单位",
            type: "string",
            align: "left",
            width: 180,
          },
          {
            field: "created_at",
            title: "创建时间",
            type: "string",
            width: 180,
            align: "center"
          },
          {
            field: "admin",
            title: "创建人",
            type: "format",
            width: 120,
            align: "center"
          },
          {
            field: "department",
            title: "创建人科室",
            type: "format",
            width: 120,
            align: "center"
          },
          {
            field: "操作",
            title: "操作",
            width: 220,
            type: "opt",
            fixed:'right'
          }
        ],
        uploadOther: {
          token: ""
        },
      }
    },
    created() {
      this.uploadOther.token = getToken();
      this.initLoad();
      this.load();

    },
    methods: {
      addRow() {
        var len = this.form.details_list.length;
        this.form.details_list.push({
            name:"",
            status:"",
            measure:"",
            remark:""
          });
      },
      delRow(index) {
        this.form.details_list.splice(index, 1);
      },
      initLoad() {
        var that = this;
        var clientHeight = document.documentElement.clientHeight
        var lxHeader_height = 96.5; //查询 头部
        var paginationHeight = 37; //分页的高度
        var topHeight = 50; //页面 头部
        let tableHeight = clientHeight - lxHeader_height - topHeight - paginationHeight - 20;
        that.tableHeight = tableHeight;

        //加载自定义参数
        getparameteritem("safetyStatus").then(res => {
          this.parameters.safetyStatus = res.detail;
        });
      },
      handleCurrentChange(page) {
        this.paginations.page = page;
        this.load();
      },
      load() {
        listtask({
          page: this.paginations.page,
          page_size: this.paginations.page_size,
          keyword:this.searchFields.KeyWord
        }).then(response => {
          this.tableData = response.data;
          this.paginations.total = response.total;
        }).catch(error => {
          console.log(error)
          reject(error)
        })

      },
      del(obj) {
        var that = this;
        if (obj) {
          this.$Modal.confirm({
            title: '确认要删除数据？',
            onOk: () => {
              del(obj.id).then(response => {
                this.$Message.success('操作成功');
                that.load();
              }).catch(error => {
                console.log(error)
                reject(error)
              })
            },
            onCancel: () => {
              //this.$Message.info('Clicked cancel');
            }
          });
        }
      },
      info(obj) {
        var that = this;

        get(obj.id).then(res => {
          let result = Object.assign(that.form, res);
          that.form = result;
          let _files = [];
          for (var mod of result.safety_item_files) {
            let m = Object.assign({}, mod["files"]);
            m.name = mod["files"].original_name;
            _files.push(m);
          }
          that.fileList = _files;
          that.form.details_list = result.details;
        }).catch(error => {
          //reject(error)
        })
      },
      edit(obj) {
        this.form = this.$options.data().form;
        this.clientHeight = document.documentElement.clientHeight - 84 - 110;
        if (obj) {
          var that = this;
          that.info(obj);
        } else {}
        this.dialogFormVisible = true;
      },
      submitForm(formName) {
        var that = this;
        this.$refs[formName].validate((valid) => {
          if (valid) {
            if (that.form.id) {
              that.form.id = that.form.id;
              save(that.form).then(response => {
                //console.log(response)
                this.$Message.success('操作成功');
                that.load();
                that.dialogFormVisible = false;
              }).catch(error => {
                //reject(error)
              })
            } else {
              store(that.form).then(response => {
                //console.log(response)
                this.$Message.success('操作成功');
                that.load();
                that.dialogFormVisible = false;
              }).catch(error => {
                //reject(error)
              })
            }
          } else {
            this.$Message.error('数据校验失败');
            console.log('error submit!!');
            return false;
          }
        });
      },
      handleRemove(file, fileList) {
        let listUrl = [];
        for (var m of fileList) {
          if (m.response)
            listUrl.push({"upload_id":m.response.id});
          else
            listUrl.push({"upload_id":m.id});
        }
        this.form.file_list = listUrl;
      },
      handleExceed(files, fileList) {},
      beforeRemove(file, fileList) {
        return this.$confirm(`确定移除 ${ file.name }？`);
      },
      handlesuccess(response, file, fileList) {
        let listUrl = [];
        for (var m of fileList) {
          if (m.response)
            listUrl.push({"upload_id":m.response.id});
          else
            listUrl.push({"upload_id":m.id});

        }
        this.form.file_list = listUrl;
      },
      resetForm(formName) {
        var that = this;
        this.fileList=[];
        this.$refs[formName].resetFields();
        that.dialogFormVisible = false;
      },
    }
  }
</script>

<style>
  .dialogConcent {
    overflow-y: auto;
  }


</style>
